----- MODULE Prime -----
EXTENDS Naturals, TLC
CONSTANT N

(* --algorithm IsPrimeAlg
	variables n \in 2..N; k = 2; m; answer = TRUE;
	begin 
		while (k < n) /\ answer do
			m := 2;
			while (m <= k) /\ answer do
				if m * k = n then 
					answer := FALSE;
				end if;
				m := m + 1;
			end while;
			k := k + 1;
		end while;
		assert answer = isprime(n);
	end algorithm
*)

isprime(n) == ~ \E k, m \in 2..n : k * m = n

\* BEGIN TRANSLATION
VARIABLES n, k, m, answer, pc

vars == << n, k, m, answer, pc >>

Init == (* Global variables *)
        /\ n \in 2..N
        /\ k = 2
        /\ m = {}
        /\ answer = TRUE
        /\ pc = "Lbl_1"

Lbl_1 == /\ pc = "Lbl_1"
         /\ IF (k < n) /\ answer
               THEN /\ m' = 2
                    /\ pc' = "Lbl_2"
               ELSE /\ Assert(answer = isprime(n), 
                              "Failure of assertion at line line 18, column 17.")
                    /\ pc' = "Done"
                    /\ UNCHANGED m
         /\ UNCHANGED << n, k, answer >>

Lbl_2 == /\ pc = "Lbl_2"
         /\ IF (m <= k) /\ answer
               THEN /\ IF m * k = n
                          THEN /\ answer' = FALSE
                          ELSE /\ TRUE
                               /\ UNCHANGED answer
                    /\ m' = m + 1
                    /\ pc' = "Lbl_2"
                    /\ UNCHANGED k
               ELSE /\ k' = k + 1
                    /\ pc' = "Lbl_1"
                    /\ UNCHANGED << m, answer >>
         /\ UNCHANGED n

Next == Lbl_1 \/ Lbl_2
           \/ (* Disjunct to prevent deadlock on termination *)
              (pc = "Done" /\ UNCHANGED vars)

Spec == Init /\ [][Next]_vars

Termination == <>(pc = "Done")

\* END TRANSLATION

=====
